using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using Microsoft.Extensions.Logging;
using AyaNova.Models;
using AyaNova.Util;
using System.IO;


namespace AyaNova.Biz
{


    /// <summary>
    /// Backup 
    /// 
    /// </summary>
    internal static class CoreJobBackup
    {
        private static ILogger log = AyaNova.Util.ApplicationLogging.CreateLogger("CoreJobBackup");
        private static bool BackupIsRunning = false;
        private const int MAXIMUM_MS_ALLOWED_FOR_PROCESSING = 5 * 60 * 1000;//wild assed guess 5 minutes maximum to run backup command, ever

        ////////////////////////////////////////////////////////////////////////////////////////////////
        // BACK-THE-FUCK-UP
        //
        public static async Task DoWorkAsync(bool OnDemand = false)
        {
            if (BackupIsRunning) return;
            if (!OnDemand)
            {
                log.LogTrace("Checking if backup should run");
                if (!ServerGlobalOpsSettingsCache.Backup.Active)
                {
                    log.LogDebug("Automatic backup is set to INACTIVE - not backing up");
                    return;
                }

                if (DateTime.UtcNow < ServerGlobalOpsSettingsCache.NextBackup)
                {
                    log.LogTrace("Not past backup time yet");
                    return;
                }
            }
            AyaNova.Api.ControllerHelpers.ApiServerState apiServerState = null;
          
            try
            {
                BackupIsRunning = true;

                //LOCK DOWN SERVER
                apiServerState = (AyaNova.Api.ControllerHelpers.ApiServerState)ServiceProviderProvider.Provider.GetService(typeof(AyaNova.Api.ControllerHelpers.ApiServerState));
                apiServerState.SetClosed("BACKUP RUNNING");
                var jobstartmessage = $"Starting backup job {(OnDemand ? "manual / on demand" : "scheduled") } ";
                await JobsBiz.LogJobAsync(Guid.Empty, jobstartmessage);
              
              DateTime dtStartBackup=DateTime.Now;
                log.LogDebug("Backup starting");
                var DemandFileNamePrepend = OnDemand ? "manual-" : string.Empty;
                //*************
                //DO DATA BACKUP
                //build command
                //this is valid on windows
                //C:\data\code\PostgreSQLPortable_12.0\App\PgSQL\bin\pg_dump --dbname=postgresql://postgres:raven@127.0.0.1:5432/AyaNova -Fc > huge_new.backup

                await JobsBiz.LogJobAsync(Guid.Empty, $"Data backup starting");
                Npgsql.NpgsqlConnectionStringBuilder PostgresConnectionString = new Npgsql.NpgsqlConnectionStringBuilder(ServerBootConfig.AYANOVA_DB_CONNECTION);
                var DBNameParameter = $"--dbname=postgresql://{PostgresConnectionString.Username}:{PostgresConnectionString.Password}@{PostgresConnectionString.Host}:{PostgresConnectionString.Port}/{PostgresConnectionString.Database}";

                var DataBackupFile = $"{DemandFileNamePrepend}db-{FileUtil.GetSafeDateFileName()}.backup";//presentation issue so don't use UTC for this one
                DataBackupFile = FileUtil.GetFullPathForBackupFile(DataBackupFile);

                var BackupUtilityCommand = "pg_dump";
                if (!string.IsNullOrWhiteSpace(ServerBootConfig.AYANOVA_BACKUP_PG_DUMP_PATH))
                    BackupUtilityCommand = Path.Combine(ServerBootConfig.AYANOVA_BACKUP_PG_DUMP_PATH, BackupUtilityCommand);

                var Arguments = $"{DBNameParameter} -Fc > {DataBackupFile}";

                var Result = RunProgram.Run(BackupUtilityCommand, Arguments, log, MAXIMUM_MS_ALLOWED_FOR_PROCESSING);
                if (string.IsNullOrWhiteSpace(Result))
                {
                    var ms = "Backup of database completed OK";
                    log.LogDebug(ms);
                   
                }
                else
                {
                    var msg = $"Error during data backup \"{Result}\"";
                    await JobsBiz.LogJobAsync(Guid.Empty, msg);
                    log.LogError($"BACKUP ERROR: {Result}");
                    await NotifyEventProcessor.AddGeneralNotifyEvent(NotifyEventType.BackupStatus, msg,"Backup");
                }

                //DO FILE BACKUP IF ATTACHMENTS BACKED UP
                if (ServerGlobalOpsSettingsCache.Backup.BackupAttachments)
                {
                    await JobsBiz.LogJobAsync(Guid.Empty, $"Attachments backup starting");
                    FileUtil.BackupAttachments(DemandFileNamePrepend);
                    var ms = "Backup of file attachments completed OK";
                    log.LogDebug(ms);                 

                }

                //PRUNE DATA BACKUP SETS NOT KEPT
                await JobsBiz.LogJobAsync(Guid.Empty, $"Pruning old backup sets");
                FileUtil.DatabaseBackupCleanUp(ServerGlobalOpsSettingsCache.Backup.BackupSetsToKeep);

                //v.next - COPY TO ONLINE STORAGE
                //***************     

                log.LogDebug("Backup completed");
                var duration=DateTime.Now - dtStartBackup;
                await NotifyEventProcessor.AddGeneralNotifyEvent(NotifyEventType.BackupStatus, $"Backup ({(OnDemand ? "manual / on demand" : "scheduled")}) completed successfully, duration (h:m:s.ms): {duration.ToString()}, server re-opened","Backup");
            }
            catch (Exception ex)
            {
                await JobsBiz.LogJobAsync(Guid.Empty, "Backup failed with errors:");
                await JobsBiz.LogJobAsync(Guid.Empty, ExceptionUtil.ExtractAllExceptionMessages(ex));
                log.LogError(ex, "Backup failed");
                await NotifyEventProcessor.AddGeneralNotifyEvent(NotifyEventType.BackupStatus, "Backup failed","Backup", ex);
                throw;
            }
            finally
            {
                //bump the backup date if automatic backup
                if (!OnDemand)
                    ServerGlobalOpsSettingsCache.SetNextBackup();
                apiServerState.ResumePriorState();
                BackupIsRunning = false;
                await JobsBiz.LogJobAsync(Guid.Empty, $"Backup - fully complete, server re-opened");
               
            }
        }



        /////////////////////////////////////////////////////////////////////
    }//eoc
}//eons

